/* Character Buffer;

   Call charbuf_finish if you want to use the buffered string and do not know its size, e.g. when using lua_pushstring, after tha last 
   append to include a terminating '\0'. */

#ifndef charbuf_h
#define charbuf_h

typedef struct {
  char *data;       /* container */
  size_t capacity;  /* maximum number of slots */
  size_t size;      /* current number of entries */
} Charbuf;

LUAI_FUNC INLINE void charbuf_init (lua_State *L, Charbuf *buf, size_t initsize);
LUAI_FUNC INLINE void charbuf_append (lua_State *L, Charbuf *buf, const char *str, size_t n);
LUAI_FUNC INLINE void charbuf_appendchar (lua_State *L, Charbuf *buf, int chr);

/* converted to macro in 2.16.13 */
#define charbuf_free(buf) { \
  free((buf)->data); \
  (buf)->data = NULL; \
}

/* 2.16.13 */
#define charbuf_finish(buf) { \
  char *__charbufpos = (buf)->data + (buf)->size; \
  __charbufpos = '\0'; \
  (void)(__charbufpos); \
}


#endif

