@echo off
rem To build and install the additional libraries, execute this file in the \agena\src subfolder
rem in a plain NT shell, and not in MinGW.

set gccopts=-Wall -Wno-attributes -pipe -O3 -shared -I. -L. -lagena -fgnu89-inline
set gccfileopts=-pipe -O3 -DLUA_BUILD_AS_DLL -fgnu89-inline -Wno-attributes
set gccfinalopts=-pipe -O3 -shared -static-libgcc -fpic -fgnu89-inline -Wno-attributes
set offs=-Wno-int-to-pointer-cast -Wno-pointer-to-int-cast

set OLDPATH=%PATH%
set PATH=%PATH%;c:\mingw\bin

del ads.o calc.o linalg.o stats.o fractals.o phq.o net.o xbase.o interp.o rlhmath.o astro.o skycrane.o llist.o hashes.o factory.o sunriset.o moon.o fastmath.o bytes.o sema.o dual.o utf8.o

echo Building ADS.
gcc %offs% %gccfileopts% -c -o ads.o ads.c
gcc -O3 -shared -static-libgcc -fgnu89-inline -fpic -o ads.dll ads.o vecoff64.o -L. -lagena

rem echo Building phonetiQs.
rem gcc %gccopts% -o phq.dll plus/phq.c
rem copy phq.dll ..\phq >> NUL
rem del phq.dll

echo Building calc.
gcc %gccfileopts% -c -o calc.o calc.c
gcc %gccfileopts% -c -o interp.o interp.c
gcc %gccfileopts% -c -o rlhmath.o rlhmath.c
gcc %gccfinalopts% -o calc.dll calc.o interp.o cephes.o rlhmath.o -L. -lagena

echo Building stats.
gcc %gccfileopts% -c -o stats.o stats.c
gcc %gccfinalopts% -o stats.dll stats.o cephes.o -L. -lagena

echo Building linalg.
gcc %gccopts% -o linalg.dll linalg.c

echo Building fractals.
gcc %gccopts% -o fractals.dll fractals.c

echo Building astro.
gcc %gccfileopts% -c -o sunriset.o sunriset.c
gcc %gccfileopts% -c -o moon.o moon.c
gcc %gccfileopts% -c -o astro.o astro.c
gcc %gccfinalopts% -o astro.dll astro.o agnt64.o sofa.o sdncal.o moon.o sunriset.o -L. -lagena

echo Building xbase.
gcc %gccfileopts% -c -o xbase.o xbase.c
gcc %gccfinalopts% -o xbase.dll xbase.o sofa.o agnt64.o -L. -lagena

echo Building net.
gcc %gccfileopts% -c -o net.o net.c
gcc %gccfinalopts% -o net.dll net.o -L. -lwsock32 -lwininet -lagena

rem echo Building net.
rem gcc %gccopts% -o net.dll net.c agnhlps.c agnt64.c cephes.c sofa.c -lwsock32

echo Building bags.
gcc %gccopts% -o bags.dll bags.c

echo Building skycrane.
gcc %gccopts% -o skycrane.dll skycrane.c

echo Building llist.
gcc %gccopts% -o llist.dll llist.c

echo Building hashes.
gcc %gccopts% -o hashes.dll hashes.c

rem echo Building compress.
rem gcc %gccopts% -o compress.dll compress.c lcompress.c agnhlps.c

rem echo Building words.
rem gcc %gccopts% -o words.dll words.c

echo Building numarray.
gcc %gccopts% -o numarray.dll numarray.c

echo Building zx.
gcc %gccopts% -o zx.dll zx.c

echo Building bloom.
gcc %gccopts% -o bloom.dll bloom.c

echo Building factory.
gcc %gccopts% -o factory.dll factory.c

echo Building fastmath.
gcc %gccopts% -o fastmath.dll fastmath.c

echo Building bytes.
gcc %gccopts% -o bytes.dll bytes.c

echo Building sema.
gcc %gccfileopts% -c -o sema.o sema.c
gcc %gccfileopts% -c -o semalib.o semalib.c
gcc %gccfinalopts% -o sema.dll sema.o semalib.o -L. -lagena

echo Building dual.
gcc %gccopts% -o dual.dll dual.c

echo Building utf8.
gcc %gccopts% -o utf8.dll utf8.c

echo Building mp.
set gmpopts=-Wall -O3 -fgnu89-inline -shared -I. -L.
set gmplibs=-lgmp -lagena
gcc %gmpopts% -o mp.dll mp.c %gmplibs%

echo.
echo Slimming and moving packages.
strip --strip-unneeded *.dll
copy ads.dll ..\lib >> NUL
copy calc.dll ..\lib >> NUL
copy stats.dll ..\lib >> NUL
copy linalg.dll ..\lib >> NUL
copy fractals.dll ..\lib >> NUL
copy xbase.dll ..\lib >> NUL
copy net.dll ..\lib >> NUL
copy bags.dll ..\lib >> NUL
copy astro.dll ..\lib >> NUL
copy skycrane.dll ..\lib >> NUL
copy llist.dll ..\lib >> NUL
copy hashes.dll ..\lib >> NUL
copy numarray.dll ..\lib >> NUL
copy zx.dll ..\lib >> NUL
copy bloom.dll ..\lib >> NUL
copy factory.dll ..\lib >> NUL
copy fastmath.dll ..\lib >> NUL
copy bytes.dll ..\lib >> NUL
copy sema.dll ..\lib >> NUL
copy dual.dll ..\lib >> NUL
copy utf8.dll ..\lib >> NUL
copy mp.dll ..\lib >> NUL

echo Installed all libraries into Agena /lib folder.

del ads.dll
del calc.dll
del stats.dll
del linalg.dll
del fractals.dll
del xbase.dll
del net.dll
del bags.dll
del astro.dll
del skycrane.dll
del llist.dll
del hashes.dll
del numarray.dll
del zx.dll
del bloom.dll
del factory.dll
del fastmath.dll
del bytes.dll
del sema.dll
del dual.dll
del utf8.dll
del mp.dll

set gccopts=
set PATH=%OLDPATH%

set OLDPATH=