/* Dynamic Vector Array, initiated September 27, 2017

   Based on: http://eddmann.com/posts/implementing-a-dynamic-vector-array-in-c, modified */

#ifndef vector_h
#define vector_h

#define VECTOR_INICAPA 16

#define VECTOR_DELETE(vec, id) 		vector_delete(&vec, id)

#define _vector_init(vec, sz) 		vector vec; vector_init(&vec, (sz))
#define _vector_free(vec) 			vector_free(&vec)
#define _vector_append(vec, item) 	vector_append(&vec, (void *)(item))
#define _vector_set(vec, id, item) 	vector_set(&vec, (id), (void *)(item))
#define _vector_get(vec, type, id)  (type)vector_get(&vec, (id))
#define _vector_getoff64_t(vec, id)	(off64_t)vector_get(&vec, (id))
#define _vector_getdouble(vec, id)	(double)vector_get(&vec, (id))
#define _vector_size(vec) 			vector_size(&vec)

typedef struct vector {
  void **data;      /* container */
  int capacity;     /* maximum number of slots */
  int size;         /* current number of entries */
  size_t itemsize;  /* = sizeof(<type>) */
} vector;

int   vector_init (vector *v, size_t itemsize);
void *vector_get (vector *v, int index);
void  vector_set (vector *v, int index, void *item);
int   vector_append (vector *v, void *item);
int   vector_insert (vector *v, int index, void *item);
int   vector_delete (vector *v, int index);
int   vector_size (vector *);
void  vector_free (vector *);

#endif

